#ifndef INCLUDE_LEARN_INTERV____LEARN____RENDEZVOUS_HPP_
#define INCLUDE_LEARN_INTERV____LEARN____RENDEZVOUS_HPP_


#include <learn/Inter__learn__rendezVous.hpp>

class Port;
class PortValue;
class ConnT__learn__rendezVous;

class InterV__learn__rendezVous : public InteractionValue {
public:
    virtual ~InterV__learn__rendezVous();

    // getters for references (declared pure virtual in interface)
    virtual const Interaction &interaction() const { return mInteraction; }
    virtual const vector<PortValue *> &portValues() const;
    virtual bool hasPortValues() const;

    // specific operations
    const vector<Port *> &ports() const { return mInteraction.ports(); }

    // Only allow the connector to call the ctor here (see createInteractionValue() method)
    friend class ConnT__learn__rendezVous;

protected:
    InterV__learn__rendezVous(const ConnT__learn__rendezVous &connector, const Interaction& interaction, const vector<PortValue *> &values);
    Inter__learn__rendezVous mInteraction;
    vector<PortValue *> &portValues();
    vector<PortValue *> mPortValues;

    void commonRecycle(const Interaction& interaction, const vector<PortValue *> &values);


}; 

inline
const vector<PortValue *> &InterV__learn__rendezVous::portValues() const {
    return this->mPortValues;
}

inline
bool InterV__learn__rendezVous::hasPortValues() const {
    return (!this->mPortValues.empty());
}

inline
vector<PortValue *> &InterV__learn__rendezVous::portValues() {
    return mPortValues;
}

#endif // INCLUDE_LEARN_INTERV____LEARN____RENDEZVOUS_HPP_
